#include <stdio.h>
#include "Python.h"
#include "weakrefobject.h"



typedef struct {
    PyObject_HEAD
} TestObject;

//PyAPI_DATA(PyTypeObject) _TestObject_Type;

static PyTypeObject _TestObject_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                         /*ob_size*/
    "test.object",             /*tp_name*/
    sizeof(TestObject), /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    0,                         /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    0,                         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT,        /*tp_flags*/
    "Noddy objects",           /* tp_doc */
};

static void
_init_weakref(PyWeakReference *self, PyObject *ob, PyObject *callback)
{
    self->hash = -1;
    self->wr_object = ob;
    Py_XINCREF(callback);
    self->wr_callback = callback;
    //Uncomment following lines and recompile to verify the fix.
    //self->wr_next = NULL;
    //self->wr_prev = NULL;

}

static PyWeakReference *
_new_weakref(PyObject *ob, PyObject *callback)
{
    PyWeakReference *result;

    result = PyObject_GC_New(PyWeakReference, &_PyWeakref_RefType);
    if (result) {
        _init_weakref(result, ob, callback);
        PyObject_GC_Track(result);
    }
    return result;
}

#define GET_WEAKREFS_LISTPTR(o) \
        ((PyWeakReference **) PyObject_GET_WEAKREFS_LISTPTR(o))

static void
_clear_weakref(PyWeakReference *self)
{
    PyObject *callback = self->wr_callback;

    if (self->wr_object != Py_None) {
        PyWeakReference **list = GET_WEAKREFS_LISTPTR(self->wr_object);

        if (*list == self)
            /* If 'self' is the end of the list (and thus self->wr_next == NULL)
               then the weakref list itself (and thus the value of *list) will
               end up being set to NULL. */
            *list = self->wr_next;
        self->wr_object = Py_None;
        if (self->wr_prev != NULL)
            self->wr_prev->wr_next = self->wr_next;
        if (self->wr_next != NULL)
            self->wr_next->wr_prev = self->wr_prev;
        self->wr_prev = NULL;
        self->wr_next = NULL;
    }
    if (callback != NULL) {
        Py_DECREF(callback);
        self->wr_callback = NULL;
    }
}



void test_init_weakref(int test_dealloc)
{
    TestObject *obj;
    obj = PyObject_GC_New(TestObject, &_TestObject_Type);   
    PyWeakReference *result;
    result = _new_weakref(obj, NULL);
    if (result) {
        printf("%x\n", result->wr_prev);
        printf("%x\n", result->wr_next);
        if (test_dealloc) {
            _clear_weakref(result);
        }
    }
}


